<template>
  <div>
    <default-spinner-component :loading-message="loadingMessage"
      v-if="loadingData"/>
    <v-layout v-if="loadedData">
      <v-flex>
        <v-card id="loginContentContainer"
          class="defaultCardBackground"
          style="margin: 0 auto;">
          <v-card-title style="padding:5px 16px;">
            <h4 style="color:#4f8196">
              User information
            </h4>
            <v-spacer></v-spacer>
            <v-btn icon
              style="color:#4f8196"
              @click.native.stop="editDialog = true">
              <v-icon>
                edit
              </v-icon>
            </v-btn>
            <v-btn icon
              @click.native.stop="dialog = true">
              <v-icon style="color:#4f8196">
                delete
              </v-icon>
            </v-btn>
          </v-card-title>
          <v-divider></v-divider>
          <ul class="sellerDetailListItem">
            <li>
              <span class="detailLabel">
                Name
              </span>
              &nbsp;&nbsp;{{userInformation.firstName}} {{userInformation.middleName}} {{userInformation.lastName}}
            </li>
            <li>
              <span class="detailLabel">
                Username
              </span>
              &nbsp;&nbsp;{{userInformation.userName}}
            </li>
            <li>
              <span class="detailLabel">
                Email
              </span>
              &nbsp;&nbsp;{{userInformation.firstName}}
            </li>
            <li>
              <span class="detailLabel">
                Role
              </span>
              &nbsp;&nbsp;{{userInformation.role}}
            </li>
          </ul>
        </v-card>
      </v-flex>
      <v-dialog v-model="dialog"
        max-width="400">
        <v-card>
          <v-progress-linear
            v-if="deleteUserRequested"
            :indeterminate="true"
            height="4"
            color="success"
            background-color="lightSuccess"
            style="height: 4px;position: absolute;top: -16px;">
          </v-progress-linear>
          <v-card-title>
            <h4 style="color:#4f8196">
              Are you shure you want to delete {{userInformation.firstName}} {{userInformation.middleName}}?
            </h4>
          </v-card-title>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn color="darkSecondary"
              depressed
              dark
              @click.native="dialog = false">
              CANCEL
            </v-btn>
            <v-btn outline
              color="error"
              @click="deleteUserClicked">
              DELETE
            </v-btn>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="editDialog"
        persistent
        max-width="500px">
        <v-card style="height: auto;width: auto;overflow-y: auto;">
          <v-progress-linear
            v-if="submitRequested"
            :indeterminate="true"
            height="4"
            color="success"
            background-color="lightSuccess"
            style="height: 4px;position: absolute;top: -16px;">
          </v-progress-linear>
          <v-card-title style="padding:0px 16px 0px 16px;">
            <h4 style="color:#4f8196">
              Edit user
            </h4>
            <v-spacer></v-spacer>
            <v-btn icon
              style="color:#757575"
              @click.native.stop="editDialog = false">
              <v-icon>
                close
              </v-icon>
            </v-btn>
          </v-card-title>
          <v-divider></v-divider>
          <form style="width:97%;margin-top:-10px;"
            @submit.prevent="$v.$touch(); editUserClicked();">
            <div class="defaultInputContainer"
              v-bind:class="{ 'form-group--error': $v.firstName.$error }">
              <input id="firstName"
                class="inputDefault"
                type="text"
                v-model.trim="firstName"
                @input="$v.firstName.$touch()"
                v-on:input="$v.firstName.$touch"
                v-bind:class="{
                  error: $v.firstName.$error,
                  valid: $v.firstName.$dirty && !$v.firstName.$invalid
                }"/>
              <label for="firstName"
                class="defaultInputPlaceholder">
                First name
              </label>
              <span class="formErrorMessage"
                v-if="$v.firstName.$error && $v.firstName.$dirty">
                Required
              </span>
              <v-icon style="color:#5A5"
                v-if="$v.firstName.$dirty && !$v.firstName.$invalid">
                check_circle
              </v-icon>
              <v-icon style="color:#FF6E40"
                v-if="$v.firstName.$error && $v.firstName.$dirty">
                cancel
              </v-icon>
            </div>
            <div class="defaultInputContainer"
              v-bind:class="{ 'form-group--error': $v.middleName.$error }">
              <input id="middleName"
                class="inputDefault"
                type="text"
                v-model.trim="middleName"
                @input="$v.middleName.$touch()"
                v-on:input="$v.middleName.$touch"
                v-bind:class="{
                  error: $v.middleName.$error,
                  valid: $v.middleName.$dirty && !$v.middleName.$invalid
                }"/>
              <label for="middleName"
                class="defaultInputPlaceholder">
                Middle name
              </label>
              <span class="formErrorMessage"
                v-if="$v.middleName.$error && $v.middleName.$dirty">
                Required
              </span>
              <v-icon style="color:#5A5"
                v-if="$v.middleName.$dirty && !$v.middleName.$invalid">
                check_circle
              </v-icon>
              <v-icon style="color:#FF6E40"
                v-if="$v.middleName.$error && $v.middleName.$dirty">
                cancel
              </v-icon>
            </div>
            <div class="defaultInputContainer"
              v-bind:class="{ 'form-group--error': $v.lastName.$error }">
              <input id="lastName"
                class="inputDefault"
                type="text"
                v-model.trim="lastName"
                @input="$v.lastName.$touch()"
                v-on:input="$v.lastName.$touch"
                v-bind:class="{
                  error: $v.lastName.$error,
                  valid: $v.lastName.$dirty && !$v.lastName.$invalid
                }"/>
              <label for="lastName"
                class="defaultInputPlaceholder">
                Last name
              </label>
              <span class="formErrorMessage"
                v-if="$v.lastName.$error && $v.lastName.$dirty">
                Required
              </span>
              <v-icon style="color:#5A5"
                v-if="$v.lastName.$dirty && !$v.lastName.$invalid">
                check_circle
              </v-icon>
              <v-icon style="color:#FF6E40"
                v-if="$v.lastName.$error && $v.lastName.$dirty">
                cancel
              </v-icon>
            </div>
            <div class="defaultInputContainer"
              v-bind:class="{ 'form-group--error': $v.emailAdress.$error }">
              <input id="emailAdress"
                class="inputDefault"
                type="email"
                v-model.trim="emailAdress"
                @input="$v.emailAdress.$touch()"
                v-on:input="$v.emailAdress.$touch"
                v-bind:class="{
                  error: $v.emailAdress.$error,
                  valid: $v.emailAdress.$dirty && !$v.emailAdress.$invalid
                }"/>
              <label for="emailAdress"
                class="defaultInputPlaceholder">
                Email adress
              </label>
              <span class="formErrorMessage"
                v-if="!$v.emailAdress.required && $v.emailAdress.$dirty">
                Required
              </span>
              <span class="formErrorMessage"
                v-if="!$v.emailAdress.email && $v.emailAdress.$dirty">
                Invalid email adress
              </span>
              <v-icon style="color:#5A5"
                v-if="$v.emailAdress.$dirty && !$v.emailAdress.$invalid">
                check_circle
              </v-icon>
              <v-icon style="color:#FF6E40"
                v-if="$v.emailAdress.$error && $v.emailAdress.$dirty">
                cancel
              </v-icon>
            </div>
            <div class="defaultInputContainer"
              v-bind:class="{ 'form-group--error': $v.userRole.$error }">
              <input id="userRole"
                class="inputDefault"
                type="text"
                v-model.trim="userRole"
                @input="$v.userRole.$touch()"
                v-on:input="$v.userRole.$touch"
                v-bind:class="{
                  error: $v.userRole.$error,
                  valid: $v.userRole.$dirty && !$v.userRole.$invalid
                }"/>
              <label for="userRole"
                class="defaultInputPlaceholder">
                Role
              </label>
              <span class="formErrorMessage"
                v-if="$v.userRole.$error && $v.userRole.$dirty">
                Required
              </span>
              <v-icon style="color:#5A5"
                v-if="$v.userRole.$dirty && !$v.userRole.$invalid">
                check_circle
              </v-icon>
              <v-icon style="color:#FF6E40"
                v-if="$v.userRole.$error && $v.userRole.$dirty">
                cancel
              </v-icon>
              <br/>
              <br/>
              <v-btn depressed
                dark
                color="darkSecondary"
                block
                type="submit"
                style="width:90%;margin: 3px auto 0px auto;">
                UPDATE USER
              </v-btn>
              <br/>
            </div>
          </form>
        </v-card>
      </v-dialog>
    </v-layout>
  </div>
</template>
<script>
import DefaultSpinnerComponent from './../common/spinner.vue'
import axios from 'axios'
import { required, email } from 'vuelidate/lib/validators'
export default {
  name: 'ViewUserComponent',
  data: () => ({
    loadingData: false,
    loadedData: false,
    userInformation: {},
    dialog: false,
    editDialog: false,
    deleteUserRequested: false,
    firstName: undefined,
    middleName: undefined,
    lastName: undefined,
    emailAdress: undefined,
    userRole: undefined,
    submitRequested: false,
    editableUser: {}
  }),
  components: {
    DefaultSpinnerComponent
  },
  computed: {
    loadingMessage () {
      return 'Loading ' + this.$route.params.id + '\'s Data'
    }
  },
  methods: {
    editUserClicked () {
      this.submitRequested = true
      this.editableUser.firstName = this.firstName
      this.editableUser.middleName = this.middleName
      this.editableUser.lastName = this.lastName
      this.editableUser.email = this.emailAdress
      this.editableUser.role = this.userRole
      axios.put('user/' + this.$route.params.id, this.editableUser)
        .then(response => {
          setTimeout(() => {
            this.submitRequested = false
            this.editDialog = false
            this.$store.commit('SHOW_SUCCESS_SNACK_BAR', 'User ' + this.$route.params.id + ' is succefully updated')
          }, 2000)
        })
        .catch(error => {
          this.submitRequested = false
          this.editDialog = false
          this.$store.commit('SHOW_ERROR_SNACK_BAR', 'Error occured on user edit: ' + error)
          this.editableUser = this.userInformation
        })
    },
    deleteUserClicked () {
      this.deleteUserRequested = true
      axios.delete('user/' + this.$route.params.id)
        .then(response => {
          setTimeout(() => {
            this.deleteUserRequested = false
            this.dialog = false
            this.loadedData = false
            this.$store.commit('SHOW_SUCCESS_SNACK_BAR', 'User ' + this.$route.params.id + ' is succefully deleted')
          }, 2000)
        })
        .catch(error => {
          this.deleteUserRequested = false
          this.$store.commit('SHOW_ERROR_SNACK_BAR', 'Error occured on user deletion: ' + error)
        })
    },
    populateData () {
      this.loadingData = true
      this.loadedData = false
      axios.get('user/' + this.$route.params.id)
        .then(response => {
          this.userInformation = response.data
          this.editableUser = response.data
          setTimeout(() => {
            this.loadingData = false
            this.loadedData = true
          }, 2000)
          this.firstName = this.userInformation.firstName
          this.middleName = this.userInformation.middleName
          this.lastName = this.userInformation.lastName
          this.emailAdress = this.userInformation.email
          this.userRole = this.userInformation.role
        })
        .catch(error => {
          this.loadingData = false
          this.loadedData = false
          this.$store.commit('SHOW_ERROR_SNACK_BAR', 'Error occured on viewing user ' + this.$route.params.id + ': ' + error)
        })
    }
  },
  watch: {
    '$route' (to, from) {
      this.populateData()
    }
  },
  created () {
    this.populateData()
  },
  validations: {
    firstName: {
      required
    },
    middleName: {
      required
    },
    lastName: {
      required
    },
    emailAdress: {
      required,
      email
    },
    userRole: {
      required
    }
  }
}
</script>
<style scoped>
#loginContentContainer{
  width: 50%;
  display: block;
  margin: 0 auto;
  padding-bottom: 50px;
}
.error {
  border: 1px solid #FF6E40 !important;
  background: #ffffff !important;
}
.error:focus {
  outline-color: #F99;
}
.valid {
  border:1px solid #43A047 !important;
}
.valid:focus {
  outline-color: #43A047;
}
@media only screen and (max-width: 920px){
  #loginContentContainer{
    width: 70% !important;
  }
}
@media only screen and (max-width: 750px){
  #loginContentContainer{
    width: 90% !important;
  }
}
@media only screen and (max-width: 400px){
  #loginContentContainer{
    width: 96% !important;
  }
}
</style>
